/* Socks Server 5
 * Copyright (C) 2003 by Matteo Ricchetti - <matteo.ricchetti@libero.it>

 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef SS5CORE_H
#define SS5CORE_H 1

/*
 * Main function: it works to serv client requests
 */
S5RetCode
  S5Core(		int s5client_socket
);

/*
 * Get network client information from socket after accept syscall
 */
inline S5RetCode
  S5GetClientInfo(	struct _SS5ClientInfo *ci,
			unsigned int s,
                        pid_t pid
);

inline void
  S5DebugMethodInfo(	pid_t pid,
                        struct _SS5MethodInfo mi
);

inline void
  S5DebugAuthInfo(	pid_t pid,
                        struct _SS5AuthInfo ai
);

inline void
  S5DebugRequestInfo(	pid_t pid,
                        struct _SS5RequestInfo ri
);

inline void
  S5DebugUdpRequestInfo(pid_t pid,
                        struct _SS5UdpRequestInfo uri
);

inline void
  S5DebugUpstreamInfo(	pid_t pid,
                        struct _SS5UpstreamInfo ui
);

inline void
  S5DebugFacilities(	pid_t pid,
                        struct _SS5Facilities fa
);

inline void
  S5DebugStatistics(	pid_t pid
);
#endif
